﻿namespace Vlákno2
{
    using Dámy;
    class VypisovačŘešení
    {
        private Řešitel řešitel;
        public VypisovačŘešení(int početDam)
        {
            PočetDam = početDam;
            řešitel = new(početDam);
        }
        public int PočetDam { get; private set; }
        public void VypišVšechnaŘešení()
        {
            try
            {
                while (řešitel.NajdiDalšíŘešení())
                {
                    řešitel.Výpis();
                    Thread.Sleep(10);                   
                }
            }
            catch { } // Úmyslně prázdná obsluha
        }
    }
    internal class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Pro ukončení stiskni Enter");
            Thread.Sleep(1000);
            var (n1, n2) = (12, 13);
            var vypisovač1 = new VypisovačŘešení(n1);
            var vypisovač2 = new VypisovačŘešení(n2);
            Thread vlákno1 = new Thread(vypisovač1.VypišVšechnaŘešení);
            Thread vlákno2 = new Thread(vypisovač2.VypišVšechnaŘešení);
            vlákno1.Start();
            vlákno2.Start();
            Console.Read();
            vlákno1.Interrupt();
            vlákno2.Interrupt();
            vlákno1.Join();
            vlákno2.Join();
            Console.Read();

            Console.WriteLine("Spočteno, vypsáno");
        }
    }
}
